summaryrefslogtreecommitdiffstats
path: root/mongodb
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2021-03-02 20:58:13 +0000
committer Eric Hameleers <alien@slackware.com>2021-03-02 20:58:13 +0000
commit66eeb1a7afdad50be2ffa13393fe000a00b81e2e (patch)
treef83acb04693768848803a945b084bd346845c913 /mongodb
parenta61bac2741b784c06ba124b1db07436daaf24b73 (diff)
downloadasb-66eeb1a7afdad50be2ffa13393fe000a00b81e2e.tar.gz
asb-66eeb1a7afdad50be2ffa13393fe000a00b81e2e.tar.xz
Initial revision
Diffstat (limited to 'mongodb')
-rwxr-xr-xmongodb/build/mongodb.SlackBuild305
-rw-r--r--mongodb/build/rc.mongodb75
-rw-r--r--mongodb/build/slack-desc19
-rw-r--r--mongodb/build/slack-required4
4 files changed, 403 insertions, 0 deletions
diff --git a/mongodb/build/mongodb.SlackBuild b/mongodb/build/mongodb.SlackBuild
new file mode 100755
index 00000000..4d99fe6f
--- /dev/null
+++ b/mongodb/build/mongodb.SlackBuild
@@ -0,0 +1,305 @@
+#!/bin/sh
+# $Id$
+# Copyright 2021 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: mongodb
+# Descr: document database server
+# URL: https://www.mongodb.org/
+# Build needs: python-cheetah3, python-psutil, python-yaml
+# Needs:
+# Changelog:
+# 4.4.4-1: 02/mar/2021 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh mongodb.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=mongodb
+VERSION=${VERSION:-4.4.4}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
+TAG=${TAG:-alien}
+
+DOCS="APACHE-2.0.txt CONTRIBUTING.rst \
+ CreativeCommons.txt LICENSE-Community.txt \
+ README README.third_party.md distsrc"
+
+# User 'mongo' (uidNr=285) and group 'mongo' (grpId=285) are also used by SBo.
+MONGO_UID=${MONGO_UID:-285}
+MONGO_GID=${MONGO_GID:-285}
+
+# User and group must be present on build system:
+if ! getent passwd mongo 1>/dev/null 2>/dev/null; then
+ printf "\n\tYou must have a 'mongo' user and group to run this script:\n"
+ printf "\t# groupadd -g $MONGO_GID mongo\n"
+ printf "\t# useradd -g $MONGO_GID -u $MONGO_UID -M -d /var/lib/mongodb -s /bin/false mongo\n\n"
+ exit 1
+fi
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-src-r${VERSION}.tar.gz"
+SRCURL="https://fastdl.mongodb.org/src/${PRGNAM}-src-r${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-src-r${VERSION}
+
+# Regular build results in mongo binaries of 1 to almost 3 GB a piece, since
+# they contain useless debug code which we then strip anyway.
+# So prevent adding debug symbols from the start:
+sed -i '/"-ggdb" if not env.TargetOSIs/d' SConstruct
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+export LDFLAGS="$SLKLDFLAGS"
+export CXXFLAGS="$SLKCFLAGS"
+export CFLAGS="$SLKCFLAGS"
+export SCONSFLAGS="$NUMJOBS"
+
+scons core \
+ --prefix=/usr \
+ --install-mode=legacy \
+ --release \
+ --disable-warnings-as-errors \
+ --ssl \
+ --use-sasl-client \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+
+scons install \
+ --prefix=$PKG/usr \
+ --install-mode=legacy \
+ --release \
+ --disable-warnings-as-errors \
+ --ssl \
+ --use-sasl-client \
+ 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Remove install script for compass:
+rm -f $PKG/usr/bin/install_compass
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\$(cat \$OLD | md5sum)" = "\$(cat \$NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+preserve_perms() {
+ NEW="\$1"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ if [ -e \$OLD ]; then
+ cp -a \$OLD \${NEW}.incoming
+ cat \$NEW > \${NEW}.incoming
+ mv \${NEW}.incoming \$NEW
+ fi
+ config \$NEW
+}
+
+preserve_perms etc/rc.d/rc.mongodb.new
+
+# Only way to create and use the correct uid and gid on the target system,
+# is to use chroot:
+chroot . <<EOR 2>/dev/null
+# Add the '${MONGO_GID}' group if it doesn't exist already:
+/usr/sbin/groupadd -g ${MONGO_GID} mongo 2> /dev/null
+
+# Add the '${MONGO_UID}' user if it doesn't exist already:
+/usr/sbin/useradd -c "MongoDB server account" -d /var/lib/mongodb -M \\
+ -s "/bin/false" -g ${MONGO_GID} -u ${MONGO_UID} mongo 2> /dev/null
+EOR
+
+# Update rc.local so that MongoDB will be started on boot
+if ! grep "rc.mongodb" etc/rc.d/rc.local 1>/dev/null 2>&1 ; then
+ cat <<_EOM_ >> etc/rc.d/rc.local
+
+if [ -x /etc/rc.d/rc.mongodb ]; then
+ # Start MongoDB server
+ echo "Starting MongoDB: /etc/rc.d/rc.mongodb start"
+ /etc/rc.d/rc.mongodb start
+fi
+_EOM_
+fi
+
+EOINS
+
+# Install a rc script:
+install -D -m0755 $SRCDIR/rc.mongodb $PKG/etc/rc.d/rc.mongodb.new
+
+# Create the database directory:
+mkdir -p $PKG/var/lib/mongodb
+chown ${MONGO_UID}:${MONGO_GID} $PKG/var/lib/mongodb
+
+# Create the log directory:
+mkdir -p $PKG/var/log/mongodb
+chown ${MONGO_UID} $PKG/var/log/mongodb
+chmod 750 $PKG/var/log/mongodb
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Manuall install the man page(s):
+mkdir -p $PKG/usr/man/man1
+install -D -m0644 debian/mongo.1 $PKG/usr/man/man1/mongo.1
+install -D -m0644 debian/mongod.1 $PKG/usr/man/man1/mongod.1
+install -D -m0644 debian/mongos.1 $PKG/usr/man/man1/mongos.1
+find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/mongodb/build/rc.mongodb b/mongodb/build/rc.mongodb
new file mode 100644
index 00000000..1c131aa8
--- /dev/null
+++ b/mongodb/build/rc.mongodb
@@ -0,0 +1,75 @@
+#!/bin/sh
+# ---------------------------------------------------------------------------
+# Slackware init script for MongoDB:
+# /etc/rc.d/rc.mongodb
+# ---------------------------------------------------------------------------
+
+USR="mongo"
+GRP="mongo"
+
+DBPATH="/var/lib/mongodb"
+LOGFILE="/var/log/mongodb/mongodb"
+PID="/var/state/mongodb.pid"
+SHELL="/bin/bash"
+
+mongo_start() {
+ touch $LOGFILE
+ chown $USR:$GRP $LOGFILE
+ touch $PID
+ chown $USR:$GRP $PID
+
+ su -l $USR -s $SHELL -c "/usr/bin/mongod --fork \
+ --dbpath=$DBPATH \
+ --pidfilepath=$PID \
+ --logpath=$LOGFILE --logappend"
+ if [ $? -eq 0 ]; then
+ echo "MongoDB server started successfully."
+ else
+ echo "MongoDB server failed to start, exiting now..."
+ exit 1
+ fi
+}
+
+mongo_stop() {
+ kill -TERM $(cat $PID)
+ if [ $? -eq 0 ]; then
+ echo "MongoDB server stopped successfully."
+ rm -f $PID
+ else
+ echo "MongoDB server shutdown failed!"
+ exit 1
+ fi
+}
+
+mongo_restart() {
+ mongo_stop
+ sleep 5
+ mongo_start
+}
+
+mongo_status() {
+ PIDS=$(pidof mongod)
+ if [ "x$PIDS" = "x" ]; then
+ echo "MongoDB is not running!"
+ else
+ echo "MongoDB is running at pid(s) ${PIDS}."
+ fi
+}
+
+case "$1" in
+ start)
+ mongo_start
+ ;;
+ stop)
+ mongo_stop
+ ;;
+ restart)
+ mongo_restart
+ ;;
+ status)
+ mongo_status
+ ;;
+ *)
+ echo $"Usage: $0 {start|stop|restart|status}"
+ ;;
+esac
diff --git a/mongodb/build/slack-desc b/mongodb/build/slack-desc
new file mode 100644
index 00000000..c2de7065
--- /dev/null
+++ b/mongodb/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+mongodb: mongodb (document database server)
+mongodb:
+mongodb: MongoDB is a general purpose, document-based, distributed database
+mongodb: built for modern application developers and for the cloud era.
+mongodb:
+mongodb:
+mongodb:
+mongodb:
+mongodb:
+mongodb: See also: https://www.mongodb.org/
+mongodb:
diff --git a/mongodb/build/slack-required b/mongodb/build/slack-required
new file mode 100644
index 00000000..df3bb843
--- /dev/null
+++ b/mongodb/build/slack-required
@@ -0,0 +1,4 @@
+python-cheetah3
+python-psutil
+python-yaml
+